Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 956)
+++ lemon/maps.h	(revision 314)
@@ -2052,56 +1973,37 @@
     }
 
-    /// \brief Gives back an item by its value.
-    ///
-    /// This function gives back an item that is assigned to
-    /// the given value or \c INVALID if no such item exists.
-    /// If there are more items with the same associated value,
-    /// only one of them is returned.
-    Key operator()(const Value& val) const {
-      typename Container::const_iterator it = _inv_map.find(val);
+    /// \brief Gives back the item by its value.
+    ///
+    /// Gives back the item by its value.
+    Key operator()(const Value& key) const {
+      typename Container::const_iterator it = _inv_map.find(key);
       return it != _inv_map.end() ? it->second : INVALID;
     }
 
-    /// \brief Returns the number of items with the given value.
-    ///
-    /// This function returns the number of items with the given value
-    /// associated with it.
-    int count(const Value &val) const {
-      return _inv_map.count(val);
-    }
-
   protected:
 
-    /// \brief Erase the key from the map and the inverse map.
-    ///
-    /// Erase the key from the map and the inverse map. It is called by the
+    /// \brief Erase the key from the map.
+    ///
+    /// Erase the key to the map. It is called by the
     /// \c AlterationNotifier.
     virtual void erase(const Key& key) {
       Value val = Map::operator[](key);
-      typename Container::iterator it;
-      for (it = _inv_map.equal_range(val).first;
-           it != _inv_map.equal_range(val).second; ++it) {
-        if (it->second == key) {
-          _inv_map.erase(it);
-          break;
-        }
+      typename Container::iterator it = _inv_map.find(val);
+      if (it != _inv_map.end() && it->second == key) {
+        _inv_map.erase(it);
       }
       Map::erase(key);
     }
 
-    /// \brief Erase more keys from the map and the inverse map.
-    ///
-    /// Erase more keys from the map and the inverse map. It is called by the
+    /// \brief Erase more keys from the map.
+    ///
+    /// Erase more keys from the map. It is called by the
     /// \c AlterationNotifier.
     virtual void erase(const std::vector<Key>& keys) {
       for (int i = 0; i < int(keys.size()); ++i) {
         Value val = Map::operator[](keys[i]);
-        typename Container::iterator it;
-        for (it = _inv_map.equal_range(val).first;
-             it != _inv_map.equal_range(val).second; ++it) {
-          if (it->second == keys[i]) {
-            _inv_map.erase(it);
-            break;
-          }
+        typename Container::iterator it = _inv_map.find(val);
+        if (it != _inv_map.end() && it->second == keys[i]) {
+          _inv_map.erase(it);
         }
       }
@@ -2109,7 +2011,7 @@
     }
 
-    /// \brief Clear the keys from the map and the inverse map.
-    ///
-    /// Clear the keys from the map and the inverse map. It is called by the
+    /// \brief Clear the keys from the map and inverse map.
+    ///
+    /// Clear the keys from the map and inverse map. It is called by the
     /// \c AlterationNotifier.
     virtual void clear() {
@@ -2120,28 +2022,25 @@
   public:
 
-    /// \brief The inverse map type of CrossRefMap.
-    ///
-    /// The inverse map type of CrossRefMap. The subscript operator gives
-    /// back an item by its value.
-    /// This type conforms to the \ref concepts::ReadMap "ReadMap" concept.
-    /// \see inverse()
+    /// \brief The inverse map type.
+    ///
+    /// The inverse of this map. The subscript operator of the map
+    /// gives back always the item what was last assigned to the value.
     class InverseMap {
     public:
-      /// \brief Constructor
+      /// \brief Constructor of the InverseMap.
       ///
       /// Constructor of the InverseMap.
-      explicit InverseMap(const CrossRefMap& inverted)
+      explicit InverseMap(const InvertableMap& inverted)
         : _inverted(inverted) {}
 
       /// The value type of the InverseMap.
-      typedef typename CrossRefMap::Key Value;
+      typedef typename InvertableMap::Key Value;
       /// The key type of the InverseMap.
-      typedef typename CrossRefMap::Value Key;
+      typedef typename InvertableMap::Value Key;
 
       /// \brief Subscript operator.
       ///
-      /// Subscript operator. It gives back an item
-      /// that is assigned to the given value or \c INVALID
-      /// if no such item exists.
+      /// Subscript operator. It gives back always the item
+      /// what was last assigned to the value.
       Value operator[](const Key& key) const {
         return _inverted(key);
@@ -2149,10 +2048,10 @@
 
     private:
-      const CrossRefMap& _inverted;
+      const InvertableMap& _inverted;
     };
 
-    /// \brief Gives back the inverse of the map.
-    ///
-    /// Gives back the inverse of the CrossRefMap.
+    /// \brief It gives back the just readable inverse map.
+    ///
+    /// It gives back the just readable inverse map.
     InverseMap inverse() const {
       return InverseMap(*this);
@@ -2161,47 +2060,39 @@
   };
 
-  /// \brief Provides continuous and unique id for the
-  /// items of a graph.
-  ///
-  /// RangeIdMap provides a unique and continuous
-  /// id for each item of a given type (\c Node, \c Arc or
-  /// \c Edge) in a graph. This id is
-  ///  - \b unique: different items get different ids,
-  ///  - \b continuous: the range of the ids is the set of integers
-  ///    between 0 and \c n-1, where \c n is the number of the items of
-  ///    this type (\c Node, \c Arc or \c Edge).
-  ///  - So, the ids can change when deleting an item of the same type.
-  ///
-  /// Thus this id is not (necessarily) the same as what can get using
-  /// the \c id() function of the graph or \ref IdMap.
-  /// This map can be inverted with its member class \c InverseMap,
-  /// or with the \c operator()() member.
-  ///
-  /// \tparam GR The graph type.
-  /// \tparam K The key type of the map (\c GR::Node, \c GR::Arc or
-  /// \c GR::Edge).
-  ///
-  /// \see IdMap
-  template <typename GR, typename K>
-  class RangeIdMap
-    : protected ItemSetTraits<GR, K>::template Map<int>::Type {
-
-    typedef typename ItemSetTraits<GR, K>::template Map<int>::Type Map;
-
-  public:
-    /// The graph type of RangeIdMap.
-    typedef GR Graph;
-    typedef GR Digraph;
-    /// The key type of RangeIdMap (\c Node, \c Arc or \c Edge).
-    typedef K Item;
-    /// The key type of RangeIdMap (\c Node, \c Arc or \c Edge).
-    typedef K Key;
-    /// The value type of RangeIdMap.
-    typedef int Value;
+  /// \brief Provides a mutable, continuous and unique descriptor for each
+  /// item in the graph.
+  ///
+  /// The DescriptorMap class provides a unique and continuous (but mutable)
+  /// descriptor (id) for each item of the same type (e.g. node) in the
+  /// graph. This id is <ul><li>\b unique: different items (nodes) get
+  /// different ids <li>\b continuous: the range of the ids is the set of
+  /// integers between 0 and \c n-1, where \c n is the number of the items of
+  /// this type (e.g. nodes) (so the id of a node can change if you delete an
+  /// other node, i.e. this id is mutable).  </ul> This map can be inverted
+  /// with its member class \c InverseMap, or with the \c operator() member.
+  ///
+  /// \tparam _Graph The graph class the \c DescriptorMap belongs to.
+  /// \tparam _Item The Item is the Key of the Map. It may be Node, Arc or
+  /// Edge.
+  template <typename _Graph, typename _Item>
+  class DescriptorMap
+    : protected ItemSetTraits<_Graph, _Item>::template Map<int>::Type {
+
+    typedef _Item Item;
+    typedef typename ItemSetTraits<_Graph, _Item>::template Map<int>::Type Map;
+
+  public:
+    /// The graph class of DescriptorMap.
+    typedef _Graph Graph;
+
+    /// The key type of DescriptorMap (Node, Arc, Edge).
+    typedef typename Map::Key Key;
+    /// The value type of DescriptorMap.
+    typedef typename Map::Value Value;
 
     /// \brief Constructor.
     ///
-    /// Constructor.
-    explicit RangeIdMap(const Graph& gr) : Map(gr) {
+    /// Constructor for descriptor map.
+    explicit DescriptorMap(const Graph& _graph) : Map(_graph) {
       Item it;
       const typename Map::Notifier* nf = Map::notifier();
@@ -2214,5 +2105,5 @@
   protected:
 
-    /// \brief Adds a new key to the map.
+    /// \brief Add a new key to the map.
     ///
     /// Add a new key to the map. It is called by the
@@ -2304,14 +2195,14 @@
     }
 
-    /// \brief Gives back the \e range \e id of the item
-    ///
-    /// Gives back the \e range \e id of the item.
+    /// \brief Gives back the \e descriptor of the item.
+    ///
+    /// Gives back the mutable and unique \e descriptor of the map.
     int operator[](const Item& item) const {
       return Map::operator[](item);
     }
 
-    /// \brief Gives back the item belonging to a \e range \e id
-    ///
-    /// Gives back the item belonging to the given \e range \e id.
+    /// \brief Gives back the item by its descriptor.
+    ///
+    /// Gives back th item by its descriptor.
     Item operator()(int id) const {
       return _inv_map[id];
@@ -2324,28 +2215,25 @@
 
   public:
-
-    /// \brief The inverse map type of RangeIdMap.
-    ///
-    /// The inverse map type of RangeIdMap. The subscript operator gives
-    /// back an item by its \e range \e id.
-    /// This type conforms to the \ref concepts::ReadMap "ReadMap" concept.
+    /// \brief The inverse map type of DescriptorMap.
+    ///
+    /// The inverse map type of DescriptorMap.
     class InverseMap {
     public:
-      /// \brief Constructor
+      /// \brief Constructor of the InverseMap.
       ///
       /// Constructor of the InverseMap.
-      explicit InverseMap(const RangeIdMap& inverted)
+      explicit InverseMap(const DescriptorMap& inverted)
         : _inverted(inverted) {}
 
 
       /// The value type of the InverseMap.
-      typedef typename RangeIdMap::Key Value;
+      typedef typename DescriptorMap::Key Value;
       /// The key type of the InverseMap.
-      typedef typename RangeIdMap::Value Key;
+      typedef typename DescriptorMap::Value Key;
 
       /// \brief Subscript operator.
       ///
       /// Subscript operator. It gives back the item
-      /// that the given \e range \e id currently belongs to.
+      /// that the descriptor belongs to currently.
       Value operator[](const Key& key) const {
         return _inverted(key);
@@ -2360,10 +2248,10 @@
 
     private:
-      const RangeIdMap& _inverted;
+      const DescriptorMap& _inverted;
     };
 
     /// \brief Gives back the inverse of the map.
     ///
-    /// Gives back the inverse of the RangeIdMap.
+    /// Gives back the inverse of the map.
     const InverseMap inverse() const {
       return InverseMap(*this);
